Feature: Add_and_delete_the_Incident_in_ServiceNow

# Below Scenario will open the selected web browser in maximize mode and will navigate to provided URL
Scenario: Precondition- Launch the broswer and navigate to Sales Force Login url
Given use "Browser1" browser for execution
Then change default timeout to "50" seconds
And navigate to URL "ServiceNow"      
When maximize window

# # Below scenario will login ServiceNow account
Scenario Outline: Login ServiceNow account
# Verify element which will appear after navigating the URL
Then verify element "serviceNowUserNameField" is displayed on the UI
And enter value "<ServiceNowUserName>" for element "serviceNowUserNameField"
And enter value "<ServiceNowPassword>" for element "serviceNowPasswordField"
And click on element "serviceNowLoginBtn"
# Verify element which will appear after successfully logging in
Then verify element "mainDOM" is displayed on the UI
Then wait for "30" seconds

Examples: 
|ServiceNowUserName|ServiceNowPassword|

# # Below scenario will add and delete an Incident
Scenario: Verify that user can add and delete an incident in ServiceNow
When use shadowdom using the selectors:
|mainDOM|
|Shadow_DOM1|
|Shadow_DOM2|
|Shadow_DOM3|
|Shadow_DOM4|
# Switch to Incidents section
And click on element "incidentsTab"
When return to default dom
Then verify element "mainDOM" is displayed on the UI
When use shadowdom using the selectors:
|mainDOM|
Then wait for "7" seconds
Then switch to frame "ServiceNow_Iframe"
When return to default dom
Then verify element "ServiceNow_NewRecordBtn" is displayed on the UI

# Add an Incident
And click on element "ServiceNow_NewRecordBtn"
Then verify element "incidentShortDescriptionField" is displayed on the UI
And enter value "This is a short description" for element "incidentShortDescriptionField"
Then click on dropdown "incidentStateDropdown" and select element "incidentChangeState"
Then click on dropdown "incidentUrgencyDropdown" and select element "incidentChangeUrgency"
Then press "CONTROL" key with the combination of "A" on element "incidentNumberField"
Then press "BACK_SPACE" key on current cursor location
Then generate random number of length "5" and store as "IncidentNumber"
Then combine "INC00" testdata with "IncidentNumber" testdata and save it as "NewIncidentNumber"
Then enter saved value "NewIncidentNumber" for element "incidentNumberField"
Then replace ?changeHere? text with text "NewIncidentNumber" in element value of name "ChangeHereElement_For_ServiceNow"
And click on element "ServiceNow_SubmitBtn"

# Verify that incident is added
Then change default timeout to "5" seconds
Then verify element "incidentShortDescriptionField" is not displayed on the UI
Then verify element "ChangeHereElement_For_ServiceNow" is displayed on the UI

# # Delete the Incident
Then change default timeout to "50" seconds
And click on element "ChangeHereElement_For_ServiceNow"
Then verify element "incidentShortDescriptionField" is displayed on the UI
Then verify element "ServiceNow_DeleteBtn" is displayed on the UI
And click on element "ServiceNow_DeleteBtn"
Then verify element "ServiceNow_DeleteRecordBtn" is displayed on the UI
And click on element "ServiceNow_DeleteRecordBtn"

# Verify that Incident is deleted
Then change default timeout to "5" seconds
Then verify element "incidentShortDescriptionField" is not displayed on the UI
Then verify element "ChangeHereElement_For_ServiceNow" is not displayed on the UI
Then switch to default frame

# Below scenario will logout ServiceNow account
Scenario: Logout ServiceNow account
Then change default timeout to "50" seconds
When use shadowdom using the selectors:
|mainDOM|
|Shadow_DOM1|
|Shadow_DOM2|
|ProfileIcon_Shadow_DOM|
And click on element "ProfileIcon"
When return to default dom
When use shadowdom using the selectors:
|mainDOM|
|Shadow_DOM1|
|Shadow_DOM2|
And click on element "userLogOutBtn"
When return to default dom
# Verify element which will appear after successfully logged out
Then verify element "serviceNowUserNameField" is displayed on the UI

# Below Scenario will close the browser 
Scenario: Postconditon- Close the browser
Then close browser
