Feature: Create_and_delete_a_state_model_in_ServiceNow

# Below Scenario will open the selected web browser in maximize mode and will navigate to provided URL
Scenario: Precondition- Launch the broswer and navigate to Sales Force Login url
Given use "Browser1" browser for execution
Then change default timeout to "50" seconds
And navigate to URL "ServiceNow"      
When maximize window

# # Below scenario will login ServiceNow account
Scenario Outline: Login ServiceNow account
# Verify element which will appear after navigating the URL
Then verify element "serviceNowUserNameField" is displayed on the UI
And enter value "<ServiceNowUserName>" for element "serviceNowUserNameField"
And enter value "<ServiceNowPassword>" for element "serviceNowPasswordField"
And click on element "serviceNowLoginBtn"
# Verify element which will appear after successfully logging in
Then verify element "mainDOM" is displayed on the UI
Then wait for "30" seconds

Examples: 
|ServiceNowUserName|ServiceNowPassword|

# # Below scenario will create and delete a State Model
Scenario: Verify that user can create and delete a State Model
When use shadowdom using the selectors:
|mainDOM|
|Shadow_DOM1|
|Shadow_DOM2|
|Shadow_DOM3|
# Switch to State Model section
And enter value "state models" for element "ServiceNow_FilterSearchField"
When use shadowdom using the selectors:
|Shadow_DOM5|
And click on element "stateModelsTab"
When return to default dom
Then verify element "mainDOM" is displayed on the UI
When use shadowdom using the selectors:
|mainDOM|
Then wait for "7" seconds
Then switch to frame "ServiceNow_Iframe"
When return to default dom
Then verify element "ServiceNow_NewRecordBtn" is displayed on the UI

# # Add a new State Model
And click on element "ServiceNow_NewRecordBtn"
Then verify element "stateModelNameField" is displayed on the UI
And enter value "This is a short description" for element "stateModelDescriptionField"
Then generate random number of length "5" and store as "StateModelName"
Then combine "State_" testdata with "StateModelName" testdata and save it as "NewStateModelName"
Then enter saved value "NewStateModelName" for element "stateModelNameField"
Then replace ?changeHere? text with text "NewStateModelName" in element value of name "ChangeHereElement_For_ServiceNow"
And click on element "ServiceNow_SubmitBtn"

# Verify that State Model is added
Then change default timeout to "5" seconds
Then verify element "stateModelNameField" is not displayed on the UI
Then verify element "ChangeHereElement_For_ServiceNow" is displayed on the UI

# # Delete the created State Model
Then change default timeout to "50" seconds
And click on element "ChangeHereElement_For_ServiceNow"
Then verify element "stateModelNameField" is displayed on the UI
Then verify element "ServiceNow_DeleteBtn" is displayed on the UI
And click on element "ServiceNow_DeleteBtn"
Then verify element "ServiceNow_DeleteRecordBtn" is displayed on the UI
And click on element "ServiceNow_DeleteRecordBtn"

# Verify that State Model is deleted
Then change default timeout to "5" seconds
Then verify element "stateModelNameField" is not displayed on the UI
Then verify element "ChangeHereElement_For_ServiceNow" is not displayed on the UI
Then switch to default frame

# Below scenario will logout ServiceNow account
Scenario: Logout ServiceNow account
Then change default timeout to "50" seconds
When use shadowdom using the selectors:
|mainDOM|
|Shadow_DOM1|
|Shadow_DOM2|
|ProfileIcon_Shadow_DOM|
And click on element "ProfileIcon"
When return to default dom
When use shadowdom using the selectors:
|mainDOM|
|Shadow_DOM1|
|Shadow_DOM2|
And click on element "userLogOutBtn"
When return to default dom
# Verify element which will appear after successfully logged out
Then verify element "serviceNowUserNameField" is displayed on the UI

# Below Scenario will close the browser 
Scenario: Postconditon- Close the browser
Then close browser
