Feature: Create_and_delete_Tag_record_in_ServiceNow

# Below Scenario will open the selected web browser in maximize mode and will navigate to provided URL
Scenario: Precondition- Launch the broswer and navigate to Sales Force Login url
Given use "Browser1" browser for execution
Then change default timeout to "50" seconds
And navigate to URL "ServiceNow"      
When maximize window

# # Below scenario will login ServiceNow account
Scenario Outline: Login ServiceNow account
# Verify element which will appear after navigating the URL
Then verify element "serviceNowUserNameField" is displayed on the UI
And enter value "<ServiceNowUserName>" for element "serviceNowUserNameField"
And enter value "<ServiceNowPassword>" for element "serviceNowPasswordField"
And click on element "serviceNowLoginBtn"
# Verify element which will appear after successfully logging in
Then verify element "mainDOM" is displayed on the UI
Then wait for "30" seconds

Examples: 
|ServiceNowUserName|ServiceNowPassword|

# # Below scenario will create and delete the Tag record
Scenario: Verify that user can create and delete the Tag record
When use shadowdom using the selectors:
|mainDOM|
|Shadow_DOM1|
|Shadow_DOM2|
|Shadow_DOM3|
|Shadow_DOM4|
# Switch to My Tags section
Then scroll mouse and make element "myTagsTab" visible
And click on element "myTagsTab"
When return to default dom
Then verify element "mainDOM" is displayed on the UI
When use shadowdom using the selectors:
|mainDOM|
Then wait for "7" seconds
Then switch to frame "ServiceNow_Iframe"
When return to default dom
Then verify element "ServiceNow_NewRecordBtn" is displayed on the UI

# # Create a Tag record
And click on element "ServiceNow_NewRecordBtn"
Then verify element "tagNameField" is displayed on the UI
Then generate random number of length "5" and store as "TagName"
Then combine "Tag_" testdata with "TagName" testdata and save it as "NewTagName"
Then enter saved value "NewTagName" for element "tagNameField"
Then replace ?changeHere? text with text "NewTagName" in element value of name "ChangeHereElement_For_ServiceNow"
Then click on dropdown "tagTypeDropdown" and select element "changeTagType"
And click on element "ServiceNow_SubmitBtn"

# Verify that Tag record is added
Then change default timeout to "5" seconds
Then verify element "tagNameField" is not displayed on the UI
Then verify element "ChangeHereElement_For_ServiceNow" is displayed on the UI

# # Delete the created Tag record
Then change default timeout to "50" seconds
And click on element "ChangeHereElement_For_ServiceNow"
Then verify element "tagNameField" is displayed on the UI
Then verify element "ServiceNow_DeleteBtn" is displayed on the UI
And click on element "ServiceNow_DeleteBtn"
Then verify element "ServiceNow_DeleteRecordBtn" is displayed on the UI
And click on element "ServiceNow_DeleteRecordBtn"

# Verify that Tag record is deleted
Then change default timeout to "5" seconds
Then verify element "tagNameField" is not displayed on the UI
Then verify element "ChangeHereElement_For_ServiceNow" is not displayed on the UI
Then switch to default frame

# Below scenario will logout ServiceNow account
Scenario: Logout ServiceNow account
Then change default timeout to "50" seconds
When use shadowdom using the selectors:
|mainDOM|
|Shadow_DOM1|
|Shadow_DOM2|
|ProfileIcon_Shadow_DOM|
And click on element "ProfileIcon"
When return to default dom
When use shadowdom using the selectors:
|mainDOM|
|Shadow_DOM1|
|Shadow_DOM2|
And click on element "userLogOutBtn"
When return to default dom
# Verify element which will appear after successfully logged out
Then verify element "serviceNowUserNameField" is displayed on the UI

# Below Scenario will close the browser 
Scenario: Postconditon- Close the browser
Then close browser
